package com.ynet.life.mvc;

import com.google.gson.JsonArray;
import com.google.gson.JsonParser;
import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.flow.GENEFlow;
import com.ynet.gene.log.GENELog;
import com.ynet.gene.session.GENESession;
import com.ynet.gene.session.InvalidSessionException;
import com.ynet.gene.session.Session;
import com.ynet.gene.session.SessionException;
import com.ynet.gene.transaction.GENETransactionManager;
import com.ynet.gene.web.servlet.ModelAndView;
import com.ynet.gene.web.servlet.mvc.BizLogicException;
import com.ynet.gene.web.servlet.mvc.GENEFlowExecuteResult;
import com.ynet.gene.web.servlet.mvc.GENERequestController;
import com.ynet.gene.web.servlet.mvc.InvalidInputException;
import com.ynet.gene.web.servlet.newmvc.InChargeOfMoreActions;
import com.ynet.life.base.LifeConstants;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.TEntity;
import com.ynet.life.base.Trace;
import com.ynet.life.exception.SessionKickoutException;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.file.parser.CommonDownloadParserFactory;
import java.io.File;
import java.io.FileInputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.StringTokenizer;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/* loaded from: com_ynet_life_mvc.jar:com/ynet/life/mvc/FileViewRequestController.class */
public class FileViewRequestController extends GENERequestController implements InChargeOfMoreActions {
    private boolean checkSession = true;
    protected Map simpleRequests;
    protected static List valuedList = new ArrayList();
    protected static List titleList = new ArrayList();
    protected static List outList = new ArrayList();
    protected static List lastList = new ArrayList();

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v10, types: [com.ynet.life.mvc.SimpleRequest, java.lang.Exception] */
    public ModelAndView doRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.openMonitor) {
            this.accessInfo.newAccess();
        }
        Map model = null;
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        ?? r0 = (SimpleRequest) this.simpleRequests.get(actionId);
        try {
            if (r0 == 0) {
                throw new GENEException("SimpleRequest for " + actionId + " not found!");
            }
            try {
                Session session = null;
                if (r0.isCheckSession() && isCheckSession()) {
                    Session doSessionCheck = doSessionCheck(request, response);
                    session = doSessionCheck;
                    if (doSessionCheck == null) {
                        Trace.logError("LifeSession", "Session not exist or timeout");
                        throw LifeConstants.EXCEPTION_SESSION_TIMEOUT;
                    }
                    doSessionKickoutCheck(request, response);
                }
                preActionWork(request, session, r0);
                request.setAttribute(GENEConstance.GENE_SESSION, session);
                String platReturnMes = (String) executeGENELogicBizFlow(request, response, session).context.getDataValue(TEntity.platReturnMesFieldname);
                String icollNames = getIcollNameByFiled(platReturnMes, "downLoadIcollName");
                String formattList = getIcollNameByFiled(platReturnMes, "dataFormate");
                String fileType = getIcollNameByFiled(platReturnMes, "downloadFileType");
                List lastList2 = setLastList(platReturnMes);
                List resultList = setFormatList(formattList);
                String fileName = "";
                if (fileType != null && fileType != "") {
                    fileName = String.valueOf(LifeStandard.getServerTime("HHmmssSSS")) + new Random().nextInt(1000) + '.' + fileType;
                }
                List iPrivateQuestion = getJsonCdValueByKey(platReturnMes, icollNames);
                response.setContentType("application/x-download");
                response.setContentType("application/vnd.ms-excel;charset=GBK");
                response.setHeader("Content-Disposition", "attachment;filename=".concat(String.valueOf(fileName)));
                ServletOutputStream output = response.getOutputStream();
                byte[] b = CommonDownloadParserFactory.createParser(fileType).writeToFile(titleList, iPrivateQuestion, outList, resultList, lastList2, fileName, "gbk");
                File fileLoad = new File(fileName);
                FileInputStream in = new FileInputStream(fileLoad);
                while (true) {
                    int n = in.read(b);
                    if (n != -1) {
                        output.write(b, 0, n);
                    } else {
                        output.flush();
                        output.close();
                        return null;
                    }
                }
            } catch (Exception e) {
                r0.printStackTrace();
                if (e instanceof InvalidInputException) {
                    e.getModel();
                } else if (e instanceof BizLogicException) {
                    ((BizLogicException) e).getModel();
                }
                throw e;
            }
        } catch (Throwable th) {
            if (0 != 0) {
                pstActionWork(request, (Context) model.get(GENEConstance.ATTR_CONTEXT), null, r0);
            }
            throw th;
        }
    }

    protected ModelAndView executeTheFlow(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Session session = null;
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        SimpleRequest simpleRequest = (SimpleRequest) this.simpleRequests.get(actionId);
        if (simpleRequest.isCheckSession() && isCheckSession()) {
            session = initSession(request, response);
        }
        if (isCheckDuplicateSubmit()) {
            doCheckDuplicateSubmit(request, response);
        }
        request.setAttribute(GENEConstance.GENE_SESSION, session);
        Map model = new HashMap();
        GENEFlowExecuteResult result = executeGENELogicBizFlow(request, response, session);
        model.put(GENEConstance.ATTR_CONTEXT, result.context);
        model.put(GENEConstance.ATTR_FLOW_OUTPUT, result.flow.getOutput(simpleRequest.getOpId()));
        if (result.e != null) {
            if (result.e instanceof InvalidInputException) {
                result.e.setModel(model);
                throw result.e;
            }
            if (result.e instanceof InvalidSessionException) {
                this.sessionManager.removeSession(session);
                throw new BizLogicException(model, result.e);
            }
            throw new BizLogicException(model, result.e);
        }
        return new ModelAndView(model, new LifePlat4MVCView());
    }

    protected GENEFlowExecuteResult executeGENELogicBizFlow(HttpServletRequest request, HttpServletResponse response, Session session) {
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        SimpleRequest simpleRequest = (SimpleRequest) this.simpleRequests.get(actionId);
        GENEFlowExecuteResult result = new GENEFlowExecuteResult();
        GENETransactionManager transactionManager = null;
        String flowId = simpleRequest.getBizId();
        GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "begin to execute flow " + flowId + " ...");
        GENEFlowExecuteResult opId = simpleRequest.getOpId();
        try {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Get flow " + flowId + "  from factory...");
            GENEFlow flow = this.geneFactory.getGENEFlow(flowId);
            result.flow = flow;
            Context context = (Context) flow.getContext().clone();
            result.context = context;
            transactionManager = (GENETransactionManager) context.getService(GENEConstance.TRX_SVC_NAME);
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Update the request data ...");
            doUpdateModel(request, context, flow, opId);
            doPreprocessModelData(request, context, flow, opId);
            addDataField(context, GENEConstance.SERVLET_REQUEST, request);
            preContextWork(request, context, simpleRequest);
            String retValue = flow.execute(context, opId);
            if (transactionManager != null) {
                transactionManager.commit();
            }
            opId = result;
            opId.result = retValue;
        } catch (Exception e) {
            opId.printStackTrace();
            GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, "Failed to execute flow ".concat(String.valueOf(flowId)), e);
            result.e = e;
            if (transactionManager != null) {
                transactionManager.rollback();
            }
        }
        return result;
    }

    public boolean isInCharge(HttpServletRequest request) {
        String actionId = (String) request.getAttribute(GENEConstance.ATTR_ACTIONID);
        if (this.simpleRequests != null && this.simpleRequests.containsKey(actionId)) {
            return true;
        }
        return false;
    }

    public void addSimpleRequest(SimpleRequest simpleRequest) {
        if (this.simpleRequests == null) {
            this.simpleRequests = new HashMap();
        }
        this.simpleRequests.put(simpleRequest.getId(), simpleRequest);
    }

    protected void preActionWork(HttpServletRequest request, Session session, SimpleRequest simpleRequest) throws TranFailException {
    }

    protected void pstActionWork(HttpServletRequest request, Context context, Throwable throwable, SimpleRequest simpleRequest) throws TranFailException {
    }

    protected void preContextWork(HttpServletRequest request, Context context, SimpleRequest simpleRequest) throws TranFailException {
    }

    public ModelAndView handleException(HttpServletRequest request, HttpServletResponse response, Exception e) {
        Map model = new HashMap();
        model.put(GENEConstance.ATTR_EXCEPTION, e);
        return new ModelAndView(model, new MVCXmlView());
    }

    private void doSessionKickoutCheck(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.sessionManager == null) {
            throw new GENEException("Session manager not set for the GENE component factory! please set it in common Service and set aliasName as [GENESessionManager] parameter in web.xml");
        }
        String appKey = request.getParameter(TEntity.appKeyFieldname);
        Session session = this.sessionManager.getSession(request, response, false);
        System.out.println("====>>>>" + session.getId());
        if (session != null && !appKey.equals(session.getId())) {
            this.sessionManager.removeSession(session);
            throw new SessionKickoutException();
        }
    }

    protected Session doSessionCheck(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.checkSession && this.sessionManager == null) {
            throw new GENEException("Session manager not set for the GENE component factory! please set it in common Service and set aliasName as [GENESessionManager] parameter in web.xml");
        }
        if ((isCheckVerifyPin() || isUseSoftKeyPin()) && this.sessionManager == null) {
            throw new GENEException("Session manager not set for the GENE component factory! please set it in common Service and set aliasName as [GENESessionManager] parameter in web.xml锛宼he GENE verifyPin and keyboard use the session to keep server side infos, please set the session manager!");
        }
        if (this.sessionManager != null) {
            GENESession sessionTime = this.sessionManager.getSession(request, response, false);
            if (sessionTime == null) {
                throw new SessionException("Session not established or timeout!");
            }
            sessionTime.setLastAccessTime(System.currentTimeMillis());
            Session session = this.sessionManager.getSession(request, response, false);
            Session session2 = session;
            if (session == null) {
                if (this.checkSession) {
                    throw new SessionException("Session not established or timeout!");
                }
                if (isCheckVerifyPin() || isUseSoftKeyPin()) {
                    session2 = this.sessionManager.getSession(request, response, true);
                }
            }
            return session2;
        }
        return null;
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v15, types: [java.lang.String] */
    /* JADX WARN: Type inference failed for: r0v3 */
    /* JADX WARN: Type inference failed for: r0v4, types: [java.lang.Exception] */
    public static String getIcollNameByFiled(String platReturnMes, String key) {
        ?? r0;
        String str = "";
        if (platReturnMes != "" && (r0 = key) != "") {
            try {
                if (platReturnMes.indexOf("jsonFlickrFeed") != -1) {
                    int beginPos = platReturnMes.indexOf("(");
                    int endPos = platReturnMes.lastIndexOf(")");
                    platReturnMes = platReturnMes.substring(beginPos + 1, endPos);
                }
                String jsonElement = new JsonParser().parse(platReturnMes).getAsJsonObject().get(TEntity.json_cd).getAsJsonObject().get(key).toString();
                r0 = jsonElement.substring(1, jsonElement.length() - 1);
                str = r0;
            } catch (Exception e) {
                r0.printStackTrace();
                str = "";
            }
        }
        return str;
    }

    public static List getJsonCdValueByKey(String platReturnMes, String key) {
        String jsonValue;
        if (platReturnMes.indexOf("jsonFlickrFeed") != -1) {
            int beginPos = platReturnMes.indexOf("(");
            int endPos = platReturnMes.lastIndexOf(")");
            platReturnMes = platReturnMes.substring(beginPos + 1, endPos);
        }
        JsonArray valueArray = new JsonParser().parse(platReturnMes).getAsJsonObject().get(TEntity.json_cd).getAsJsonObject().get(key).getAsJsonArray();
        clearList(titleList);
        clearList(outList);
        clearList(valuedList);
        for (int i = 0; i < valueArray.size(); i++) {
            HashMap hashMap = new HashMap();
            String valueList = valueArray.get(i).toString();
            String[] json1 = valueList.substring(1, valueList.length() - 1).split(",");
            for (int j = 0; j < json1.length; j++) {
                String jsonKey = json1[j].split(":")[0];
                String jsonKey2 = jsonKey.substring(1, jsonKey.length() - 1);
                String jsonValue2 = json1[j].split(":")[1];
                if (jsonValue2.equals("null") || jsonValue2.equals(null) || jsonValue2.equals("")) {
                    jsonValue = "";
                } else {
                    jsonValue = jsonValue2.substring(1, jsonValue2.length() - 1);
                }
                String[] downArray = getIcollNameByFiled(platReturnMes, "downLoadList").split("&");
                for (String str : downArray) {
                    if (str.equals(jsonKey2)) {
                        if (i >= valueArray.size() - 1) {
                            System.out.println(String.valueOf(jsonKey2) + jsonValue);
                            titleList.add(jsonValue);
                            outList.add(jsonKey2);
                        }
                        if (i < valueArray.size() - 1) {
                            hashMap.put(jsonKey2, jsonValue);
                        }
                    }
                }
            }
            if (i < valueArray.size() - 1) {
                valuedList.add(hashMap);
            }
        }
        Trace.logInfo("输入的标题列表：", titleList.toString());
        Trace.logInfo("输入的参数列表：", outList.toString());
        Trace.logInfo("输入的值的列表：", valuedList.toString());
        return valuedList;
    }

    public static List clearList(List contentList) {
        while (0 < contentList.size()) {
            contentList.remove(0);
        }
        return contentList;
    }

    public static List setFormatList(String formattList) {
        List resultList = new ArrayList();
        StringTokenizer toke = new StringTokenizer(formattList, "&");
        while (toke.hasMoreElements()) {
            String input = ((String) toke.nextElement()).trim();
            resultList.add(input);
        }
        return resultList;
    }

    public static List setLastList(String platReturnMes) {
        clearList(lastList);
        if (platReturnMes.indexOf("downloadLastData") > 0 && platReturnMes.indexOf("lastDataName") > 0) {
            String lastData = getIcollNameByFiled(platReturnMes, "downloadLastData");
            String lastDataName = getIcollNameByFiled(platReturnMes, "lastDataName");
            if (lastData != "" && lastDataName != "") {
                String[] lastArray = lastData.split("&");
                String[] dataName = lastDataName.split("&");
                HashMap hashMap = new HashMap();
                for (int k = 0; k < lastArray.length; k++) {
                    String lastKey = dataName[k];
                    String key = lastArray[k];
                    String lastValue = getIcollNameByFiled(platReturnMes, key);
                    hashMap.put(lastKey, lastValue);
                }
                lastList.add(hashMap);
                return lastList;
            }
        }
        return lastList;
    }
}
